/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   PaperChipAutocomplete.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {LitElement, html, css} from 'lit-element';

import {ArcScrollTargetMixin} from '@advanced-rest-client/arc-scroll-target-mixin/arc-scroll-target-mixin.js';

import {ArcOverlayMixin} from '@advanced-rest-client/arc-overlay-mixin/arc-overlay-mixin.js';

export {PaperChipAutocomplete};

declare namespace UiElements {

  /**
   * An autocomplete element for `paper-chip-input`.
   * It is a lightweigth version of `paper-autocomplete` element.
   *
   * ### Styling
   *
   * ## Styling
   *
   * `<paper-chip-autocomplete>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--paper-chip-autocomplete-background-color` | Background color of the element. | `inherit`
   * `--box-shadow-2dp` | Value for `box-shadow` set on  this element. | ``
   *
   * `<paper-chip>` provides the following [parts](https://www.w3.org/TR/css-shadow-parts-1/):
   *
   * Part name | Description
   * ----------------|-------------
   * `paper-item` | Styles applied to a paper-item element
   * `paper-chip-autocomplete-item` | The same as `paper-item` but less general.
   */
  class PaperChipAutocomplete extends
    ArcOverlayMixin(
    ArcScrollTargetMixin(
    Object)) {

    /**
     * The value of the input field connected to this autocomplete
     */
    value: string|null|undefined;

    /**
     * True if the overlay is currently displayed.
     *    
     */
    opened: any;

    /**
     * List of suggestions to render when the user type in the input field.
     *
     * Each array item can be a string which will be compared to user input.
     * If the item is an object is must contain the `value` property which
     * is used to compare the values. It can also contain `icon` property
     * which is used to render `<iron-icon>`. It may also contain
     * `image` property which is used to pass to `<iron-image>` element.
     *
     * ### Example
     *
     * ```json
     * [
     *  "item 1",
     *  {
     *    "value": "Other item",
     *    "icon": "add"
     *  },
     *  {
     *    "value": "Image item",
     *    "image": "path/to/image.png"
     *  }
     * ]
     * ```
     */
    source: any;

    /**
     * Computed value, `true` if has any suggestions to render.
     */
    _hasSuggestions: boolean|null|undefined;

    /**
     * List of computed and sotred suggestion to render.
     */
    _suggestions: Array<object|null>|null;

    /**
     * Sizing target element. It is used to compute the size of the
     * autocomplete container.
     */
    sizingTarget: HTMLElement|null;

    /**
     * The input element used to input value.
     * It is used to observe keys pressed
     */
    inputTarget: HTMLElement|null;

    /**
     * Currently selected item on a suggestions list.
     */
    selectedItem: Number|null;
    _computeSuggestions(value: any, source: any): void;

    /**
     * Opens the suggestions if list of suggestions changed
     */
    _hasSuggestionsChanged(hasSuggestions: Boolean|null): void;

    /**
     * Highlight previous suggestion
     */
    selectPrevious(): void;

    /**
     * Highlight next suggestion
     */
    selectNext(): void;

    /**
     * Accepts currently selected suggestion and enters it into a text field.
     */
    acceptSelection(): void;

    /**
     * Dispatches non bubbling `selected` custom event.
     *
     * @param value Selected suggestion value.
     */
    _inform(value: object|null): void;

    /**
     * Ensure that the selected item is visible in the scroller.
     * When there is more elements to show than space available (height)
     * then some elements will be hidden. When the user use arrows to navigate
     * the selection may get out from the screen. This function ensures that
     * currently selected element is visible.
     *
     * @param bottom If trully it will ensure that the element is
     * visible at the bottom of the container. On the top otherwise.
     */
    ensureItemVisible(bottom: Boolean|null): void;
    _itemClickHandler(e: any): void;
    _selectedItemChanged(e: any): void;
    _selectPreviousHandler(): void;
    _selectNextHandler(): void;
    _acceptSelectionHandler(): void;
    _suggestionsTemplate(): any;
    render(): any;
  }
}
